this.name           = "oolite-thargoid-warship";
this.author         = "Thargoid";
this.copyright      = "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description    = "New ship script for Thargoid warships - overwrites and replaces the trunk one";
this.version        = "1.00";
"use strict";

this.shipSpawned = function()
	{
	this.ship.group = new ShipGroup();
	this.ship.group.addShip(this.ship);
	this.ship.group.leader = this.ship;
	this.$reanimate();
	this.scanTimer = new Timer(this, this.$scanForThargons, Math.ceil(Math.random() * 15));
	}

this.shipDied = function()
	{
	this.$stopTimer();
	this.ship.commsMessage(expandDescription("[thargoid_curses]"));
	}

this.$scanForThargons = function()
	{
	delete this.scanTimer;
	if(!player.ship || !this.ship || !player.ship.isValid || !this.ship.isValid) { return; }	

	if(this.ship.position.distanceTo(player.ship.position) < 25600 && Math.random() < (manifest.alienItems * 0.01))
		{
		player.consoleMessage("Focussed alien beam detected.");
		player.consoleMessage("Scooped Thargons activated! Weapon fire detected in hold!");
		player.ship.takeInternalDamage();
		player.ship.energy *= (0.2 + (Math.random() * 0.7));
		manifest.alienItems--;
		for(var i=0; i < manifest.alienItems; i++)
			{ 
			if(Math.random() < 0.5) 
				{ 
				this.ejected = player.ship.ejectItem("thargon"); 
				this.$swapEntity(this.ejected);
				manifest.alienItems--;
				} 
			}
		}
		
	if(Math.random() > 0.5) { this.$reanimate(); }
	
	if(Math.random() > 0.9 && this.ship.hasHostileTarget && worldScripts["Lazarus WorldScript"])
		{ worldScripts["Lazarus WorldScript"].$startCountdown(this.ship); }	

	this.scanTimer = new Timer(this, this.$scanForThargons, (15 + Math.ceil(Math.random() * 75)));
	}
	
this.playerWillEnterWitchspace = function()
	{
	if(worldScripts["Lazarus WorldScript"])
		{ worldScripts["Lazarus WorldScript"].$stopCountdown(); }
	}	
	
this.$stopTimer = function()
	{
	if(this.scanTimer && this.scanTimer.isRunning)
		{ 
		this.scanTimer.stop(); 
		delete this.scanTimer;
		}
	}
	
this.$reanimate = function() 
	{ 
	function isUncontrolledThargon(entity) 
		{ 
		return (entity.isShip && (entity.hasRole("thargon") || entity.hasRole("tharglet")) && !entity.isThargoid && entity.isCargo && entity.AI === "dumbAI.plist");
    	}

	var thargonArray = system.filteredEntities(this, isUncontrolledThargon, this.ship, 25600)	
	if(thargonArray.length > 0)
		{
		var thargCounter = thargonArray.length - 1; // reset the counter
		for(thargCounter = thargonArray.length - 1; thargCounter >= 0; thargCounter--)
			{ 
			this.chance = Math.random();
			if(this.chance < 0.5) { this.$swapEntity(thargonArray[thargCounter]); }
			if(this.chance > 0.9) { thargonArray[thargCounter].explode(); }
			}
		}
	}

this.$swapEntity = function(entity)
	{
	if(!entity || entity === null || !entity.isValid) { return; }
	let newThargons = system.addShips("[" + entity.dataKey + "]", 1);
	newThargon = newThargons[0];
	newThargon.position = entity.position; 
	newThargon.orientation = entity.orientation; 
	this.ship.group.addShip(newThargon);
	if(this.ship && this.ship.target && this.ship.target.isValid) { newThargon.target = this.ship.target; }
	entity.remove();
	}